#include <iostream>
#include <fstream>

#define DEB(A)

using namespace std ;

struct task {
	int C ;
	double U ;
	double avg_lat, max_lat ;
} ;

// SHARED GLOBAL VARIABLES!!!!!

int M ; // current number of processors
double Lambda_min ; // current lambda_min


double calc_lambda_min(const task in_ts[], int num_in_ts, double M_g,
		       int num_summed) {
	if (num_in_ts == 0 || num_summed == M - 1)
		return 0 ;

	double max_lambda_min = 0 ;
	
	task new_in_ts[num_in_ts - 1] ;

	for (int i = 0 ; i < num_in_ts ; i++) {
		if (i > 0)
			new_in_ts[i-1] = in_ts[i-1] ;
		else
		    for (int j = i ; j < num_in_ts - 1 ; j++)
			new_in_ts[j] = in_ts[j + 1] ;

		
		double res = calc_lambda_min(new_in_ts, num_in_ts - 1,
				    M_g - in_ts[i].U, num_summed + 1) ;

		double lambda_min = in_ts[i].C/M_g + res ;
		
		DEB(for (int k = 0 ; k < num_summed ; k++)
			    cout<<"\t") ;

		DEB(cout<<"num_summed "<<num_summed
		    <<", i "<<i
		    <<", C_i "<<in_ts[i].C
		    <<", num_in_ts "<<num_in_ts<<", M_g "<<M_g
		    <<", lambda_min = "
		    <<in_ts[i].C<<"/"<<M_g<<"+"<<res
		    <<" = "<<lambda_min
		    <<endl );

		if (max_lambda_min < lambda_min)
			max_lambda_min = lambda_min ;
	}

	return max_lambda_min ;
}

double max_up_bound ; // shared variable used in next recursive
		      // function to return result!!!

void _calc_sum_up_bound(const task in_ts[], int num_in_ts, double M_g,
			 int num_summed, double partial_sum)
{
	if (num_in_ts == 1 || num_summed == M - 2) {
		DEB(cout<<"M_{M-1} "<<M_g<<endl) ;
		
		double up_bound = M_g * partial_sum ;
		
		int max_C = in_ts[0].C;
		
		for (int i = 1 ; i < num_in_ts ; i++)
			if (in_ts[i].C > max_C)
				max_C = in_ts[i].C ;
		
		up_bound += max_C ;
		
		if(max_up_bound < up_bound) {
			max_up_bound = up_bound ;
			DEB(cout<<"update_max_up_bound "<<max_up_bound<<endl);
		}
		return ;
	}

	task new_in_ts[num_in_ts - 1] ;

	for (int i = 0 ; i < num_in_ts ; i++) {
		if (i > 0)
			new_in_ts[i-1] = in_ts[i-1] ;
		else
			for (int j = 0 ; j < num_in_ts - 1 ; j++)
				new_in_ts[j] = in_ts[j + 1] ;

		double new_partial_sum = partial_sum +
			(Lambda_min * in_ts[i].U) / (M_g * (M_g - in_ts[i].U)) +
			in_ts[i].C/M_g ;
		
		DEB(for (int k = 0 ; k < num_summed ; k++)
			    cout<<"\t") ;

		DEB(cout<<"num_summed "<<num_summed
		    <<", i "<<i
		    <<", C_i "<<in_ts[i].C
		    <<", num_in_ts "<<num_in_ts<<", M_g "<<M_g
		    <<", partial_sum = "
		    <<partial_sum<<" + "
		    <<(Lambda_min * in_ts[i].U)<<"/"
		    <<"("<<M_g<<"*"<<(M_g - in_ts[i].U)<<")"
		    <<"+"
		    <<in_ts[i].C/M_g
		    <<" = "<<new_partial_sum
		    <<endl );

		_calc_sum_up_bound(new_in_ts, num_in_ts - 1,
				   M_g - in_ts[i].U,
				   num_summed + 1, new_partial_sum) ;
	}
}


void calc_sum_up_bound(const task in_ts[], int num_in_ts, double M_g,
		       int num_summed, double partial_sum)
{
	max_up_bound = 0 ;
	_calc_sum_up_bound(in_ts, num_in_ts, M_g, num_summed, partial_sum) ;
}

double calc_base_th_bound(const task ts[], int N, int M) {
		  Lambda_min = M * calc_lambda_min(ts, N, M, 0) ;
		  DEB(cout<<"Lambda_min: "<<Lambda_min<<endl) ;

                  calc_sum_up_bound(ts, N, M, 0, 0) ;

		  return max_up_bound / M ;
}

int main(int argc, char* argv[])
{
	if (argc < 2 || !strcmp(argv[1], "help") ) {
		cout<<"Usage: calc-bound_raio-from-tasksets <filename> [bounds/max_ratios]"<<endl ;
		return 1 ;
	}
	
	ifstream f(argv[1]) ;
	
	int N_heavy, N_light ;

	while(f>>M>>N_heavy>>N_light) {
		int N = N_heavy + N_light ;
		double M_1M = ((double) (M - 1)) / M ;

		// cout<<M<<" "<<N<<endl ;

		task ts[N] ;

		for (int i = 0 ; i < N ; i++) {
			double period ;

			f>>ts[i].C ;
			f>>period ;
			ts[i].U = ts[i].C / period ;
			DEB(cout<<"Task "<<i<<": "<<ts[i].C<<" "
			    <<ts[i].U<<endl );
		}

		double base_th_bound = calc_base_th_bound(ts, N, M) ;
		DEB(cout<<"Bas th. bound: "<<base_th_bound<<endl) ;
		  
		double max_ratio = 0 ;

		enum {bounds, max_ratios} mode ;

		if (!strcmp(argv[2], "bounds"))
			mode = bounds ;
		else
			mode = max_ratios ;

		for (int i = 0 ; i < N ; i++) {
			f>>ts[i].avg_lat>>ts[i].max_lat ;

			if (!f) {
			    cerr<<"File truncated"<<endl ;
			    return 1 ;
			}

			double th_bound = base_th_bound + M_1M * ts[i].C ;
			
			if (mode == bounds)
				cout<<th_bound<<endl ;
			else {
				double ratio = ts[i].max_lat / th_bound ;
				
				if (ratio > max_ratio)
					max_ratio = ratio ;
			}
		}
		
		if (mode == max_ratios)
			cout<<max_ratio<<endl ;
	} ;
}
