#!/bin/bash

in_file=$1

if [[ "$in_file" == "" ]]; then
    echo Usage:
    echo create_tasksets-from-medf_out.sh \<medf-out_file_name\>
    exit
fi

egrep -i '^Iteration|^Heavy task [0-9]|^Light task [0-9]|^Task [0-9]|^, [0-9]* light tasks' \
$in_file | egrep -v 'actual maximum' > $in_file-semiparsed1

# to remedy some extra lines that may be erroneously left in the output:
# join the header 'Iteration' line with the next one, if the number
# of light tasks is reported in the latter
awk '/\)$/ { getline t; print $0 t; next }; 1' < $in_file-semiparsed1 \
   > $in_file-semiparsed2 

sed 's/Iteration .*(\([0-9]*\)\/.*: *\([0-9]*\) heavy.*, \([0-9]*\) light.*/\1 \2 \3/' \
$in_file-semiparsed2 \
| sed 's/.* task [0-9]*:.* time \([0-9]*\), period \([0-9]*\).*/\1 \2/' \
| sed 's/Task [0-9]*:.* lateness \(.[^,]*\), max lateness \(.[^,]*\), .*/\1 \2/'

rm $in_file-semiparsed*
